// xolotl
// this template file is used by xolotl.transpile() to convert
// the xolotl pseudo-object in MATLAB into a C++
// file that can be compiled from mex
// DON'T TOUCH ANYTHING HERE!

#include <cmath>
#include <vector>
#include <typeinfo>
#include "mex.h"
//xolotl:include_headers_here
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/conductance.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/synapse.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/mechanism.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/compartment.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/network.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/extra_methods.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/conductances/Leak.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/conductances/prinz/Kd.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/conductances/prinz/NaV.hpp"
#include "/Users/smbaca/Desktop/xolotl_class/xolotl/c++/synapses/dayan-abbott/AlphaSynapse.hpp"


using namespace std;




void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{



    // declare pointers to outputs
    double *output_state;
    double *output_V;
    double *output_Ca;
    double *output_I_clamp;
    double *output_curr_state; // currents
    double *output_syn_state;  // synapses
    double *output_cont_state; // mechanisms
    double *spiketimes;

    double *mech_sizes_out;
    double *syn_sizes_out;


    int n_conductances = 0;
    int n_mechanisms = 0;
    int n_synapses = 0;


    int nsteps;
    int progress_report;

    int nsteps_out;
    int n_comp;
    int res;

    int full_current_size = 0;
    int full_mechanism_size = 0;
    int full_synaptic_size = 0;

    int spikes_only = 0;

    network xolotl_network;

    int I_ext_size_1;
    int I_ext_size_2;
    int V_clamp_size_1;
    int V_clamp_size_2;


    bool is_voltage_clamped;
    bool is_multi_comp;
    bool is_multi_step;


    int output_idx = 0;
    int cont_idx = 0;
    int cond_idx = 0;
    int syn_idx = 0;

    int percent_complete = 10;


    double * params  = mxGetPr(prhs[0]);
    //xolotl:input_declarations
double approx_channels = params[0];
double dt = params[1];
double neuronA_A = params[2];
double neuronA_AlphaSynapseneuronD_E = params[3];
double neuronA_AlphaSynapseneuronD_V_thresh = params[4];
double neuronA_AlphaSynapseneuronD_gmax = params[5];
double neuronA_AlphaSynapseneuronD_s = params[6];
double neuronA_AlphaSynapseneuronD_tau_s = params[7];
double neuronA_Ca = params[8];
double neuronA_Ca_average = params[9];
double neuronA_Ca_out = params[10];
double neuronA_Cm = params[11];
double neuronA_Kd_E = params[12];
double neuronA_Kd_gbar = params[13];
double neuronA_Kd_m = params[14];
double neuronA_Leak_E = params[15];
double neuronA_Leak_gbar = params[16];
double neuronA_NaV_E = params[17];
double neuronA_NaV_gbar = params[18];
double neuronA_NaV_h = params[19];
double neuronA_NaV_m = params[20];
double neuronA_V = params[21];
double neuronA_len = params[22];
double neuronA_neuron_idx = params[23];
double neuronA_radius = params[24];
double neuronA_shell_thickness = params[25];
double neuronA_tree_idx = params[26];
double neuronA_vol = params[27];
double neuronB_A = params[28];
double neuronB_AlphaSynapseneuronD_E = params[29];
double neuronB_AlphaSynapseneuronD_V_thresh = params[30];
double neuronB_AlphaSynapseneuronD_gmax = params[31];
double neuronB_AlphaSynapseneuronD_s = params[32];
double neuronB_AlphaSynapseneuronD_tau_s = params[33];
double neuronB_Ca = params[34];
double neuronB_Ca_average = params[35];
double neuronB_Ca_out = params[36];
double neuronB_Cm = params[37];
double neuronB_Kd_E = params[38];
double neuronB_Kd_gbar = params[39];
double neuronB_Kd_m = params[40];
double neuronB_Leak_E = params[41];
double neuronB_Leak_gbar = params[42];
double neuronB_NaV_E = params[43];
double neuronB_NaV_gbar = params[44];
double neuronB_NaV_h = params[45];
double neuronB_NaV_m = params[46];
double neuronB_V = params[47];
double neuronB_len = params[48];
double neuronB_neuron_idx = params[49];
double neuronB_radius = params[50];
double neuronB_shell_thickness = params[51];
double neuronB_tree_idx = params[52];
double neuronB_vol = params[53];
double neuronC_A = params[54];
double neuronC_AlphaSynapseneuronA_E = params[55];
double neuronC_AlphaSynapseneuronA_V_thresh = params[56];
double neuronC_AlphaSynapseneuronA_gmax = params[57];
double neuronC_AlphaSynapseneuronA_s = params[58];
double neuronC_AlphaSynapseneuronA_tau_s = params[59];
double neuronC_AlphaSynapseneuronB_E = params[60];
double neuronC_AlphaSynapseneuronB_V_thresh = params[61];
double neuronC_AlphaSynapseneuronB_gmax = params[62];
double neuronC_AlphaSynapseneuronB_s = params[63];
double neuronC_AlphaSynapseneuronB_tau_s = params[64];
double neuronC_Ca = params[65];
double neuronC_Ca_average = params[66];
double neuronC_Ca_out = params[67];
double neuronC_Cm = params[68];
double neuronC_Kd_E = params[69];
double neuronC_Kd_gbar = params[70];
double neuronC_Kd_m = params[71];
double neuronC_Leak_E = params[72];
double neuronC_Leak_gbar = params[73];
double neuronC_NaV_E = params[74];
double neuronC_NaV_gbar = params[75];
double neuronC_NaV_h = params[76];
double neuronC_NaV_m = params[77];
double neuronC_V = params[78];
double neuronC_len = params[79];
double neuronC_neuron_idx = params[80];
double neuronC_radius = params[81];
double neuronC_shell_thickness = params[82];
double neuronC_tree_idx = params[83];
double neuronC_vol = params[84];
double neuronD_A = params[85];
double neuronD_Ca = params[86];
double neuronD_Ca_average = params[87];
double neuronD_Ca_out = params[88];
double neuronD_Cm = params[89];
double neuronD_Kd_E = params[90];
double neuronD_Kd_gbar = params[91];
double neuronD_Kd_m = params[92];
double neuronD_Leak_E = params[93];
double neuronD_Leak_gbar = params[94];
double neuronD_NaV_E = params[95];
double neuronD_NaV_gbar = params[96];
double neuronD_NaV_h = params[97];
double neuronD_NaV_m = params[98];
double neuronD_V = params[99];
double neuronD_len = params[100];
double neuronD_neuron_idx = params[101];
double neuronD_radius = params[102];
double neuronD_shell_thickness = params[103];
double neuronD_tree_idx = params[104];
double neuronD_vol = params[105];
double output_type = params[106];
double sim_dt = params[107];
double solver_order = params[108];
double spike_thresh = params[109];
double stochastic_channels = params[110];
double t_end = params[111];
double temperature = params[112];
double temperature_ref = params[113];
double use_current = params[114];
double verbosity = params[115];
int param_size = 116;


        

    // make an empty network
    xolotl_network = network();

    vector<synapse*> all_synapses; // pointers to all synapses





    //xolotl:insert_constructors
compartment neuronA(neuronA_V,neuronA_Ca,neuronA_Cm,neuronA_A,neuronA_vol,neuronA_Ca_average,neuronA_tree_idx,neuronA_neuron_idx,neuronA_radius,neuronA_len,neuronA_shell_thickness,neuronA_Ca_out);
AlphaSynapse neuronA_AlphaSynapseneuronD(neuronA_AlphaSynapseneuronD_gmax,neuronA_AlphaSynapseneuronD_s,neuronA_AlphaSynapseneuronD_tau_s,neuronA_AlphaSynapseneuronD_V_thresh,neuronA_AlphaSynapseneuronD_E);
Kd neuronA_Kd(neuronA_Kd_gbar,neuronA_Kd_E,neuronA_Kd_m);
Leak neuronA_Leak(neuronA_Leak_gbar,neuronA_Leak_E);
NaV neuronA_NaV(neuronA_NaV_gbar,neuronA_NaV_E,neuronA_NaV_m,neuronA_NaV_h);
compartment neuronB(neuronB_V,neuronB_Ca,neuronB_Cm,neuronB_A,neuronB_vol,neuronB_Ca_average,neuronB_tree_idx,neuronB_neuron_idx,neuronB_radius,neuronB_len,neuronB_shell_thickness,neuronB_Ca_out);
AlphaSynapse neuronB_AlphaSynapseneuronD(neuronB_AlphaSynapseneuronD_gmax,neuronB_AlphaSynapseneuronD_s,neuronB_AlphaSynapseneuronD_tau_s,neuronB_AlphaSynapseneuronD_V_thresh,neuronB_AlphaSynapseneuronD_E);
Kd neuronB_Kd(neuronB_Kd_gbar,neuronB_Kd_E,neuronB_Kd_m);
Leak neuronB_Leak(neuronB_Leak_gbar,neuronB_Leak_E);
NaV neuronB_NaV(neuronB_NaV_gbar,neuronB_NaV_E,neuronB_NaV_m,neuronB_NaV_h);
compartment neuronC(neuronC_V,neuronC_Ca,neuronC_Cm,neuronC_A,neuronC_vol,neuronC_Ca_average,neuronC_tree_idx,neuronC_neuron_idx,neuronC_radius,neuronC_len,neuronC_shell_thickness,neuronC_Ca_out);
AlphaSynapse neuronC_AlphaSynapseneuronA(neuronC_AlphaSynapseneuronA_gmax,neuronC_AlphaSynapseneuronA_s,neuronC_AlphaSynapseneuronA_tau_s,neuronC_AlphaSynapseneuronA_V_thresh,neuronC_AlphaSynapseneuronA_E);
AlphaSynapse neuronC_AlphaSynapseneuronB(neuronC_AlphaSynapseneuronB_gmax,neuronC_AlphaSynapseneuronB_s,neuronC_AlphaSynapseneuronB_tau_s,neuronC_AlphaSynapseneuronB_V_thresh,neuronC_AlphaSynapseneuronB_E);
Kd neuronC_Kd(neuronC_Kd_gbar,neuronC_Kd_E,neuronC_Kd_m);
Leak neuronC_Leak(neuronC_Leak_gbar,neuronC_Leak_E);
NaV neuronC_NaV(neuronC_NaV_gbar,neuronC_NaV_E,neuronC_NaV_m,neuronC_NaV_h);
compartment neuronD(neuronD_V,neuronD_Ca,neuronD_Cm,neuronD_A,neuronD_vol,neuronD_Ca_average,neuronD_tree_idx,neuronD_neuron_idx,neuronD_radius,neuronD_len,neuronD_shell_thickness,neuronD_Ca_out);
Kd neuronD_Kd(neuronD_Kd_gbar,neuronD_Kd_E,neuronD_Kd_m);
Leak neuronD_Leak(neuronD_Leak_gbar,neuronD_Leak_E);
NaV neuronD_NaV(neuronD_NaV_gbar,neuronD_NaV_E,neuronD_NaV_m,neuronD_NaV_h);



    //xolotl:define_v_clamp_idx


    
    int v = (int) verbosity;
    if (v == 0) {v=1;}


    // temperature and other wire-ups
    xolotl_network.temperature = temperature;
    xolotl_network.temperature_ref = temperature_ref;

    xolotl_network.sim_dt = sim_dt;
    xolotl_network.dt = dt;

    xolotl_network.verbosity = v;
    xolotl_network.approx_channels = approx_channels;
    xolotl_network.stochastic_channels = (int) stochastic_channels;

    xolotl_network.use_current = (int) use_current;


    


    //xolotl:add_neurons_to_network
xolotl_network.addCompartment(&neuronA);
xolotl_network.addCompartment(&neuronB);
xolotl_network.addCompartment(&neuronC);
xolotl_network.addCompartment(&neuronD);


    //xolotl:add_conductances_here
neuronA.addConductance(&neuronA_Kd);
neuronA.addConductance(&neuronA_Leak);
neuronA.addConductance(&neuronA_NaV);
neuronB.addConductance(&neuronB_Kd);
neuronB.addConductance(&neuronB_Leak);
neuronB.addConductance(&neuronB_NaV);
neuronC.addConductance(&neuronC_Kd);
neuronC.addConductance(&neuronC_Leak);
neuronC.addConductance(&neuronC_NaV);
neuronD.addConductance(&neuronD_Kd);
neuronD.addConductance(&neuronD_Leak);
neuronD.addConductance(&neuronD_NaV);


    //xolotl:add_synapses_here
neuronC_AlphaSynapseneuronA.connect(&neuronA, &neuronC); n_synapses ++; all_synapses.push_back(&neuronC_AlphaSynapseneuronA);
neuronC_AlphaSynapseneuronB.connect(&neuronB, &neuronC); n_synapses ++; all_synapses.push_back(&neuronC_AlphaSynapseneuronB);
neuronA_AlphaSynapseneuronD.connect(&neuronD, &neuronA); n_synapses ++; all_synapses.push_back(&neuronA_AlphaSynapseneuronD);
neuronB_AlphaSynapseneuronD.connect(&neuronD, &neuronB); n_synapses ++; all_synapses.push_back(&neuronB_AlphaSynapseneuronD);


    //xolotl:add_mechanisms_here
n_mechanisms = 0;




    xolotl_network.init();


    if (v%5 == 0) {
        mexPrintf("\n[CHANNELS]\n ");

        if (approx_channels == 1) { mexPrintf("approximate, ");}
        else  {mexPrintf("exact, ");}

        if (stochastic_channels == 1) { mexPrintf("stochastic\n");}
        else  {mexPrintf("deterministic\n");}


        mexPrintf("[TIME]\n dt = %f, ", dt);
        mexPrintf("sim_dt = %f, ", sim_dt);
        mexPrintf("t_end = %f, \n", t_end);


    }





    nsteps = (int) floor(t_end/sim_dt);
    progress_report = (int) floor(nsteps/10);

    nsteps_out = (int) floor(t_end/dt);
    n_comp = (int) (xolotl_network.comp).size(); // these many compartments


    // ask each mechanism (nicely) what their
    // full state size is
    int full_mechanism_sizes[n_comp];
    full_mechanism_size = 0;
    for (int i = 0; i < n_comp; i ++) {
        int n_mech = (xolotl_network.comp[i])->n_mech;

        full_mechanism_sizes[i] = xolotl_network.comp[i]->getFullMechanismSize();
        full_mechanism_size += full_mechanism_sizes[i];
    }


    // compute ionic current state dimensions
    // assumed to be the same for all conductances
    full_current_size = 0;
    for (int i = 0; i < n_comp; i ++) {
        full_current_size += (xolotl_network.comp[i])->n_cond;
    }

    // compute synapse state dim
    int full_synaptic_sizes[n_comp];
    full_synaptic_size = 0;
    for (int i = 0; i < n_comp; i ++) {
        int n_syn = (xolotl_network.comp[i])->n_syn;

        full_synaptic_sizes[i] = xolotl_network.comp[i]->getFullSynapseSize();
        full_synaptic_size += full_synaptic_sizes[i];
    }

    // set up outputs as mex objects
    res = dt/sim_dt;


    // ask all the mechanisms for their sizes
    int begin_mechanism_sizes = param_size;
    param_size = param_size + n_mechanisms;

    if (nrhs == 1) {
        // the only thing we are being asked to do is compute the mechanism
        // and synapse sizes and return that. once we're done, abort
        plhs[0] = mxCreateDoubleMatrix(n_mechanisms, 1, mxREAL);
        mech_sizes_out = mxGetPr(plhs[0]);

        int idx = 0;
        for(int j = 0; j < n_comp; j++) {
            for (int k = 0; k < xolotl_network.comp[j]->n_mech; k++) {
                int mech_size = (xolotl_network.comp[j]->getMechanismPointer(k))->fullStateSize;
                mech_sizes_out[idx] = mech_size;
                idx++;
            }
        }


        plhs[1] = mxCreateDoubleMatrix(n_synapses, 1, mxREAL);
        syn_sizes_out = mxGetPr(plhs[1]);

        
        idx = 0;
        for(int j = 0; j < n_comp; j++) {
            for (int k = 0; k < xolotl_network.comp[j]->n_syn; k++) {
                int syn_size = (xolotl_network.comp[j]->getSynapsePointer(k))->fullStateSize;
                syn_sizes_out[idx] = syn_size;
                idx++;
            }
        }

        return;
    }


    plhs[0] = mxCreateDoubleMatrix(param_size, 1, mxREAL);
    output_state = mxGetPr(plhs[0]);

    


    if (v%5 == 0) {
        mexPrintf("\n[#COMP]   [MECH SIZE]   [CURRENT SIZE]   [SYN SIZE]\n ");
        mexPrintf(   "%i            ",n_comp);
        mexPrintf(   "%i            ",full_mechanism_size);
        mexPrintf(   "%i            ",full_current_size);
        mexPrintf(   "%i         \n",full_synaptic_size);



    }


    if (nlhs > 1) {
        plhs[1] = mxCreateDoubleMatrix(n_comp, nsteps_out, mxREAL);
        output_V = mxGetPr(plhs[1]);
    }
    if (nlhs > 2) {
        plhs[2] = mxCreateDoubleMatrix(2*n_comp, nsteps_out, mxREAL);
        output_Ca = mxGetPr(plhs[2]);
    }

    if (nlhs > 3) {
        plhs[3] = mxCreateDoubleMatrix(full_mechanism_size, nsteps_out, mxREAL);
        output_cont_state = mxGetPr(plhs[3]);
    }

    if (nlhs > 4) {
        plhs[4] = mxCreateDoubleMatrix(full_current_size, nsteps_out, mxREAL);
        output_curr_state = mxGetPr(plhs[4]);
    }

    if (nlhs > 5) {
        plhs[5] = mxCreateDoubleMatrix(full_synaptic_size, nsteps_out, mxREAL);
        output_syn_state = mxGetPr(plhs[5]);
    }

    // return another output for spiketimes
    if (nlhs > 6) {
        plhs[6] = mxCreateDoubleMatrix(nsteps_out, n_comp, mxREAL);
        spiketimes = mxGetPr(plhs[6]);
    }

    // link up I_ext and V_clamp
    double * I_ext = new double[n_comp];
    double * V_clamp = new double[n_comp];
    double * I_ext_in = mxGetPr(prhs[1]);
    double * V_clamp_in = mxGetPr(prhs[2]);


    // create arrays to help us find spikes
    // and return just the spiketimes
    double * prev_V = new double[n_comp];
    int * spike_time_idx = new int[n_comp];
    spikes_only = 0;
    if (output_type == 2){
        spikes_only = 1;
        for (int i = 0; i < n_comp; i ++){
            spike_time_idx[i] = 0;
            prev_V[i] = -200;
        }
    }

    // figure out the sizes of the arrays
    // for V_clamp and I_ext
    const mwSize *I_ext_dim, *V_clamp_dim;
    I_ext_dim = mxGetDimensions(prhs[1]);
    V_clamp_dim = mxGetDimensions(prhs[2]);

    I_ext_size_1 = I_ext_dim[0];
    I_ext_size_2 = I_ext_dim[1];
    V_clamp_size_1 = V_clamp_dim[0];
    V_clamp_size_2 = V_clamp_dim[1];



    if (v%5 == 0) {
        mexPrintf("\n[I_EXT] ");
        if (I_ext_size_2 == nsteps) {mexPrintf(" dynamically changing\n");}
        else { mexPrintf("fixed \n");}


        mexPrintf("\n[V_CLAMP] ");
        if (V_clamp_size_2 == nsteps) {mexPrintf(" dynamically changing\n\n");}
        else { mexPrintf("fixed \n\n");}
    }



    // copy I_ext so we can use it
    for(int q = 0; q < n_comp; q++) {
        I_ext[q] = I_ext_in[q];
        V_clamp[q] = V_clamp_in[q];
        // mexPrintf("I_ext =  %f ", I_ext_in[q]);
    }



    // determine mode
    is_voltage_clamped = false;
    is_multi_comp = xolotl_network.resolveTree();
    is_multi_step = false;

    if (solver_order > 0) {
        is_multi_step = true;
        xolotl_network.solver_order = (int) solver_order;

        // check that every component has a supported
        // solver that can work with this order
        xolotl_network.checkSolvers();
    }

    // figure out if we're voltage clamping
    // if any V_clamp is non-NaN, then we are

    for (int j = 0; j < n_comp; j++) {
        if (!isnan(V_clamp[j])) {
            is_voltage_clamped = true;
        }
    }


    mexEvalString("drawnow;");

    percent_complete = 10;


    if (is_multi_comp & is_multi_step){
        mexErrMsgTxt("[xolotl] multi-compartment models cannot be integrated with multi-step methods yet. \n");
    }


    output_idx = 0;
    cont_idx = 0;
    cond_idx = 0;
    syn_idx = 0;

    if (v%5 == 0){
        mexPrintf("[C++] %i outputs requested\n", nlhs);
    }


    // tell all components about some core
    // parameters
    // xolotl_network.broadcast(sim_dt, temperature);

    if (!is_voltage_clamped & !is_multi_step){

//
//                                  _         ___
//              _ __ ___   ___   __| | ___   / _ |
//             | '_ ` _ \ / _ \ / _` |/ _ \ | | | |
//             | | | | | | (_) | (_| |  __/ | |_| |
//             |_| |_| |_|\___/ \__,_|\___|  \___/



        for (int i = 0; i < nsteps; i++) {
            if (I_ext_size_2 == nsteps) {
                // I_ext is dynamically changing
                for(int q = 0; q < n_comp; q++) {
                    I_ext[q] = I_ext_in[i*n_comp + q];
                }
            }

            xolotl_network.integrate(I_ext);


            if (i%progress_report == 0 & v%5 == 0) {
                mexPrintf("[C++] integration %i %", percent_complete);
                mexPrintf(" complete\n");
                percent_complete += 10;
                mexEvalString("drawnow;");
            }

            // here we're getting the state of every compartment -- V, Ca, and all conductances
            if (i%res == 0) {

                switch (nlhs) {
                    case 1:
                        // only one output, do nothing
                        break;
                    case 2:
                        // read out voltages only
                        for (int j = 0; j < n_comp; j++) {
                            output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                        } // end j loop over compartments
                        break;

                    case 3:
                        // V + Ca
                        for (int j = 0; j < n_comp; j++) {
                            output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;

                        } // end j loop over compartments
                        break;

                    case 4:
                        // V, Ca, mechanisms

                        for (int j = 0; j < n_comp; j++) {
                            output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));

                        } // end j loop over compartments
                        break;


                    case 5:
                        // V, Ca, C, I
                        for (int j = 0; j < n_comp; j++) {
                            output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));
                            cond_idx = (xolotl_network.comp[j]->getFullCurrentState(output_curr_state,cond_idx));

                        } // end j loop over compartments
                        break;



                    default:
                        // V, Ca, Ca, I, Syn
                        for (int j = 0; j < n_comp; j++) {

                            output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;

                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));
                            cond_idx = (xolotl_network.comp[j]->getFullCurrentState(output_curr_state,cond_idx));
                        } // end j loop over compartments

                        for (int k = 0; k < n_synapses; k++) {
                            syn_idx = (all_synapses[k]->getFullState(output_syn_state,syn_idx));
                        }

                        break;
                } // switch
                output_idx ++;
            } // if we need to write output



            // do we need to return spike times?
            switch (spikes_only){

                case 0:
                    break;
                case 1:
                    // must return just spike times
                    for (int j = 0; j < n_comp; j++) {
                        if ((prev_V[j] < spike_thresh) && ((xolotl_network.comp[j]->V) > spike_thresh)) {
                            spiketimes[spike_time_idx[j] + j*nsteps_out] = i;
                            spike_time_idx[j]++;
                        }
                        prev_V[j] = xolotl_network.comp[j]->V;
                    } // end j loop over compartments
                    break;
            }




        } // end for loop over nsteps


    } else if (is_voltage_clamped & !is_multi_step) {

//                             _           _
//         _ __ ___   ___   __| | ___     / |
//        | '_ ` _ \ / _ \ / _` |/ _ \    | |
//        | | | | | | (_) | (_| |  __/    | |
//        |_| |_| |_|\___/ \__,_|\___|    |_|



        // do the integration respecting V_clamp

        for (int i = 0; i < nsteps; i++) {

            if (V_clamp_size_2 == nsteps) {
                // I_ext is dynamically changing
                for(int q = 0; q < n_comp; q++) {
                    V_clamp[q] = V_clamp_in[i*n_comp + q];
                }
            }

            xolotl_network.integrateClamp(V_clamp);

            if (i%progress_report == 0 & v%5 == 0) {
                mexPrintf("[C++] integration %i %", percent_complete);
                mexPrintf(" complete\n");
                percent_complete += 10;
                mexEvalString("drawnow;");
            }


            // here we're getting the state of every compartment -- V, Ca, and all conductances
            if (i%res == 0) {

                switch (nlhs) {
                    case 1:
                        // only one output, do nothing
                        break;
                    case 2:
                        // read out voltages only
                        for (int j = 0; j < n_comp; j++) {
                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }
                        } // end j loop over compartments
                        break;

                    case 3:
                        // V + Ca
                        for (int j = 0; j < n_comp; j++) {
                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;

                        } // end j loop over compartments
                        break;

                    case 4:
                        // V, Ca, mechanisms

                        for (int j = 0; j < n_comp; j++) {
                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));

                        } // end j loop over compartments
                        break;


                    case 5:
                        // V, Ca, C, I
                        for (int j = 0; j < n_comp; j++) {
                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));
                            cond_idx = (xolotl_network.comp[j]->getFullCurrentState(output_curr_state,cond_idx));

                        } // end j loop over compartments
                        break;



                    default:
                        // V, Ca, Ca, I, Syn
                        for (int j = 0; j < n_comp; j++) {

                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }

                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));
                            cond_idx = (xolotl_network.comp[j]->getFullCurrentState(output_curr_state,cond_idx));
                        } // end j loop over compartments

                        for (int k = 0; k < n_synapses; k++) {
                            syn_idx = (all_synapses[k]->getFullState(output_syn_state,syn_idx));
                        }

                        break;
                } // switch
                output_idx ++;
            } // if we need to write output




        } // end for loop over nsteps


    } else if (!is_voltage_clamped & is_multi_step) {
//
//                            _        ____
//        _ __ ___   ___   __| | ___  |___ \
//       | '_ ` _ \ / _ \ / _` |/ _ \   __) |
//       | | | | | | (_) | (_| |  __/  / __/
//       |_| |_| |_|\___/ \__,_|\___| |_____|


        if (v%5 == 0) {
            mexPrintf("[xolotl] %i-step integration requested.\n", xolotl_network.solver_order);

        }




        for (int i = 0; i < nsteps; i++) {
            if (I_ext_size_2 == nsteps) {
                // I_ext is dynamically changing
                for(int q = 0; q < n_comp; q++) {
                    I_ext[q] = I_ext_in[i*n_comp + q];
                }
            }

            xolotl_network.integrateMS(I_ext);


            if (i%progress_report == 0 & v%5 == 0) {
                mexPrintf("[C++] integration %i %", percent_complete);
                mexPrintf(" complete\n");
                percent_complete += 10;
                mexEvalString("drawnow;");
            }



            // here we're getting the state of every compartment -- V, Ca, and all conductances
            if (i%res == 0) {

                for (int j = 0; j < n_comp; j++)
                {

                    if (nlhs > 1) {
                        output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                    }

                    if (nlhs > 2) {
                        output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                        output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                    }

                    if (nlhs > 3) {
                        cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));
                    }

                    if (nlhs > 4) {
                        cond_idx = (xolotl_network.comp[j]->getFullCurrentState(output_curr_state,cond_idx));
                    }

                } // end j loop over compartments

                // read out synaptic currents and full
                // state of all synapses
                if (nlhs > 5) {
                    for (int k = 0; k < n_synapses; k++) {
                        syn_idx = (all_synapses[k]->getFullState(output_syn_state,syn_idx));
                    }
                }
                output_idx ++;
            } // end read out variables



            // do we need to return spike times?
            switch (spikes_only){

                case 0:
                    break;
                case 1:
                    // must return just spike times
                    for (int j = 0; j < n_comp; j++) {
                        if ((prev_V[j] < spike_thresh) && ((xolotl_network.comp[j]->V) > spike_thresh)) {
                            spiketimes[spike_time_idx[j] + j*nsteps_out] = i;
                            spike_time_idx[j]++;
                        }
                        prev_V[j] = xolotl_network.comp[j]->V;
                    } // end j loop over compartments
                    break;
            }


        } // end for loop over nsteps




    } else if (is_voltage_clamped & is_multi_step) {

        // .___  ___.   ______    _______   _______     ____
        // |   \/   |  /  __  \  |       \ |   ____|   |___ \
        // |  \  /  | |  |  |  | |  .--.  ||  |__        __) |
        // |  |\/|  | |  |  |  | |  |  |  ||   __|      |__ <
        // |  |  |  | |  `--'  | |  '--'  ||  |____     ___) |
        // |__|  |__|  \______/  |_______/ |_______|   |____/
        //

        if (v%5 == 0) {
            mexPrintf("[xolotl] %i-step integration requested.\n", xolotl_network.solver_order);
        }

        // do the integration respecting V_clamp

        for (int i = 0; i < nsteps; i++) {

            if (V_clamp_size_2 == nsteps) {
                // I_ext is dynamically changing
                for(int q = 0; q < n_comp; q++) {
                    V_clamp[q] = V_clamp_in[i*n_comp + q];
                }
            }

            xolotl_network.integrateClamp(V_clamp); // this needs to change

            if (i%progress_report == 0 & v%5 == 0) {
                mexPrintf("[C++] integration %i %", percent_complete);
                mexPrintf(" complete\n");
                percent_complete += 10;
                mexEvalString("drawnow;");
            }

            // here we're getting the state of every compartment -- V, Ca, and all conductances
            if (i%res == 0) {

                switch (nlhs) {
                    case 1:
                        // only one output, do nothing
                        break;
                    case 2:
                        // read out voltages only
                        for (int j = 0; j < n_comp; j++) {
                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }
                        } // end j loop over compartments
                        break;

                    case 3:
                        // V + Ca
                        for (int j = 0; j < n_comp; j++) {
                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;

                        } // end j loop over compartments
                        break;

                    case 4:
                        // V, Ca, mechanisms

                        for (int j = 0; j < n_comp; j++) {
                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));

                        } // end j loop over compartments
                        break;


                    case 5:
                        // V, Ca, C, I
                        for (int j = 0; j < n_comp; j++) {
                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }
                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));
                            cond_idx = (xolotl_network.comp[j]->getFullCurrentState(output_curr_state,cond_idx));

                        } // end j loop over compartments
                        break;



                    default:
                        // V, Ca, Ca, I, Syn
                        for (int j = 0; j < n_comp; j++) {

                            if (isnan(V_clamp[j])) {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->V;
                            }
                            else {
                                output_V[output_idx*n_comp + j] = xolotl_network.comp[j]->I_clamp;
                            }

                            output_Ca[output_idx*2*n_comp + j] = xolotl_network.comp[j]->Ca;
                            output_Ca[output_idx*2*n_comp + j + n_comp] = xolotl_network.comp[j]->E_Ca;
                            cont_idx = (xolotl_network.comp[j]->getFullMechanismState(output_cont_state,cont_idx));
                            cond_idx = (xolotl_network.comp[j]->getFullCurrentState(output_curr_state,cond_idx));
                        } // end j loop over compartments

                        for (int k = 0; k < n_synapses; k++) {
                            syn_idx = (all_synapses[k]->getFullState(output_syn_state,syn_idx));
                        }

                        break;
                } // switch
                output_idx ++;
            } // if we need to write output

        } // end for loop over nsteps

    } else  {
        mexErrMsgTxt("[xolotl] Unknown integration mode. \n");
    }



    // now measure the mean Ca in every compartment
    for(int j = 0; j < n_comp; j++)
    {
        (xolotl_network.comp[j]->Ca_average) = (xolotl_network.comp[j]->Ca_average)/nsteps;
    }

    // here, we are reading the full state back, so we
    // can easily update the xolotl object in the MATLAB wrapper
    //xolotl:read_state_back
output_state[0] = params[0];
output_state[1] = params[1];
output_state[2] = neuronA.A;
output_state[3] = neuronA_AlphaSynapseneuronD.E;
output_state[4] = neuronA_AlphaSynapseneuronD.V_thresh;
output_state[5] = neuronA_AlphaSynapseneuronD.gmax;
output_state[6] = neuronA_AlphaSynapseneuronD.s;
output_state[7] = neuronA_AlphaSynapseneuronD.tau_s;
output_state[8] = neuronA.Ca;
output_state[9] = neuronA.Ca_average;
output_state[10] = neuronA.Ca_out;
output_state[11] = neuronA.Cm;
output_state[12] = neuronA_Kd.E;
output_state[13] = neuronA_Kd.gbar;
output_state[14] = neuronA_Kd.m;
output_state[15] = neuronA_Leak.E;
output_state[16] = neuronA_Leak.gbar;
output_state[17] = neuronA_NaV.E;
output_state[18] = neuronA_NaV.gbar;
output_state[19] = neuronA_NaV.h;
output_state[20] = neuronA_NaV.m;
output_state[21] = neuronA.V;
output_state[22] = neuronA.len;
output_state[23] = neuronA.neuron_idx;
output_state[24] = neuronA.radius;
output_state[25] = neuronA.shell_thickness;
output_state[26] = neuronA.tree_idx;
output_state[27] = neuronA.vol;
output_state[28] = neuronB.A;
output_state[29] = neuronB_AlphaSynapseneuronD.E;
output_state[30] = neuronB_AlphaSynapseneuronD.V_thresh;
output_state[31] = neuronB_AlphaSynapseneuronD.gmax;
output_state[32] = neuronB_AlphaSynapseneuronD.s;
output_state[33] = neuronB_AlphaSynapseneuronD.tau_s;
output_state[34] = neuronB.Ca;
output_state[35] = neuronB.Ca_average;
output_state[36] = neuronB.Ca_out;
output_state[37] = neuronB.Cm;
output_state[38] = neuronB_Kd.E;
output_state[39] = neuronB_Kd.gbar;
output_state[40] = neuronB_Kd.m;
output_state[41] = neuronB_Leak.E;
output_state[42] = neuronB_Leak.gbar;
output_state[43] = neuronB_NaV.E;
output_state[44] = neuronB_NaV.gbar;
output_state[45] = neuronB_NaV.h;
output_state[46] = neuronB_NaV.m;
output_state[47] = neuronB.V;
output_state[48] = neuronB.len;
output_state[49] = neuronB.neuron_idx;
output_state[50] = neuronB.radius;
output_state[51] = neuronB.shell_thickness;
output_state[52] = neuronB.tree_idx;
output_state[53] = neuronB.vol;
output_state[54] = neuronC.A;
output_state[55] = neuronC_AlphaSynapseneuronA.E;
output_state[56] = neuronC_AlphaSynapseneuronA.V_thresh;
output_state[57] = neuronC_AlphaSynapseneuronA.gmax;
output_state[58] = neuronC_AlphaSynapseneuronA.s;
output_state[59] = neuronC_AlphaSynapseneuronA.tau_s;
output_state[60] = neuronC_AlphaSynapseneuronB.E;
output_state[61] = neuronC_AlphaSynapseneuronB.V_thresh;
output_state[62] = neuronC_AlphaSynapseneuronB.gmax;
output_state[63] = neuronC_AlphaSynapseneuronB.s;
output_state[64] = neuronC_AlphaSynapseneuronB.tau_s;
output_state[65] = neuronC.Ca;
output_state[66] = neuronC.Ca_average;
output_state[67] = neuronC.Ca_out;
output_state[68] = neuronC.Cm;
output_state[69] = neuronC_Kd.E;
output_state[70] = neuronC_Kd.gbar;
output_state[71] = neuronC_Kd.m;
output_state[72] = neuronC_Leak.E;
output_state[73] = neuronC_Leak.gbar;
output_state[74] = neuronC_NaV.E;
output_state[75] = neuronC_NaV.gbar;
output_state[76] = neuronC_NaV.h;
output_state[77] = neuronC_NaV.m;
output_state[78] = neuronC.V;
output_state[79] = neuronC.len;
output_state[80] = neuronC.neuron_idx;
output_state[81] = neuronC.radius;
output_state[82] = neuronC.shell_thickness;
output_state[83] = neuronC.tree_idx;
output_state[84] = neuronC.vol;
output_state[85] = neuronD.A;
output_state[86] = neuronD.Ca;
output_state[87] = neuronD.Ca_average;
output_state[88] = neuronD.Ca_out;
output_state[89] = neuronD.Cm;
output_state[90] = neuronD_Kd.E;
output_state[91] = neuronD_Kd.gbar;
output_state[92] = neuronD_Kd.m;
output_state[93] = neuronD_Leak.E;
output_state[94] = neuronD_Leak.gbar;
output_state[95] = neuronD_NaV.E;
output_state[96] = neuronD_NaV.gbar;
output_state[97] = neuronD_NaV.h;
output_state[98] = neuronD_NaV.m;
output_state[99] = neuronD.V;
output_state[100] = neuronD.len;
output_state[101] = neuronD.neuron_idx;
output_state[102] = neuronD.radius;
output_state[103] = neuronD.shell_thickness;
output_state[104] = neuronD.tree_idx;
output_state[105] = neuronD.vol;
output_state[106] = params[106];
output_state[107] = params[107];
output_state[108] = params[108];
output_state[109] = params[109];
output_state[110] = params[110];
output_state[111] = params[111];
output_state[112] = params[112];
output_state[113] = params[113];
output_state[114] = params[114];
output_state[115] = params[115];


}

